import sys
import json
import hashlib

# sudo pip install stix
#from stix.core import STIXPackage

def hashfilter(digest, data):
	iocs = []

	if digest == 'md5' or digest == 'imphash':
		for ioc in data:
			if len(ioc) == 32:
				iocs.append(ioc)
		return iocs

	elif digest == 'sha1':
		for ioc in data:
			if len(ioc) == 40:
				iocs.append(ioc)
		return iocs

	elif digest == 'sha256':
		for ioc in data:
			if len(ioc) == 64:
				iocs.append(ioc)
		return iocs
		
	else:
		print ('Error in hashlist file format')
		sys.exit()

def fromfile(digest, filename, encrypted=False):

	# Json
	"""
	{
		"md5": [
			"3960a3c8029d1c61b390b54809694d3d",
			"e0d897a466ecb61efc625174597623c9"
		],
		"sha256": [
			"1ab5ffabaf6b0e9010911dc33bc5c997f49c3fe9c3f6256811d8406f3a08edd9",
			"8c674e97d0eba69fbca12f663ac5ce56223059ad942d808ab1b81275a4bfeaaa"
		]
	}

	try:
		with open(filename) as f:
			data = json.load(f)
		return data[digest]
	except:
		pass
	"""

	# Stix 1.2
	"""
	try:
		data = []
		stix_package = STIXPackage.from_xml(filename)

		for ind in stix_package.indicators:
			for obs in ind.observables:
				try:
					for dgs in obs.object_.properties.hashes:
						data.append(str(dgs))
				except:
					# IoC Network:
					# print (obs.object_.properties)
					pass

		return hashfilter(digest, data)
	except:
		pass
	"""
	
	# Hashlist
	try:
		f = open(filename,'r')
		data = f.read().split('\n')
		f.close
		return hashfilter(digest, data)
	except:
		pass
	
