import sys
import time

import hashcalc
import filepath

def hashfolder(digest, path_to_folder, recursive, duplicate, filetype, exclude):
	
	print              ('--[ directory mapping  : '+str(path_to_folder))
	if recursive: print('--[ recursive mode     : '+str(recursive))
	if duplicate: print('--[ duplicate check    : '+str(duplicate))
	if filetype: print ('--[ filetype extension : '+str(filetype))
	if exclude: print  ('--[ exclude mode       : '+str(exclude))
	
	filelist = filepath.getlist(path_to_folder, recursive, filetype, exclude)
	filecount = len(filelist)

	print              ('--[ files mapped       : '+str(filecount))
	print              ('--[ searching for      : '+str(digest)+'\n')
	
	empty = ['d41d8cd98f00b204e9800998ecf8427e', \
			'da39a3ee5e6b4b0d3255bfef95601890afd80709', \
			'e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855']

	processed = 0
	hashs_list = []
	empty_list = []
	start_time = time.time()

	for file in filelist:

		#print file

		if digest == 'md5':	
			hashval = hashcalc.md5(file)
			if hashval == empty[0]: empty_list.append([hashval, file])
			
		elif digest == 'sha1': 
			hashval = hashcalc.sha1(file)
			if hashval == empty[1]: empty_list.append([hashval, file])
			
		elif digest == 'sha256': 
			hashval = hashcalc.sha256(file)
			if hashval == empty[2]: empty_list.append([hashval, file])
			
		elif digest == 'imphash': 
			hashval = hashcalc.imphash(file)
		else:
			print('Hash algorithm not valid')
			sys.exit()

		if hashval != None:
			processed += 1
			print(hashval+' '+file)
			hashs_list.append([hashval, file])

	print('\n--[ '+str(processed)+' files processed in %s seconds' % (time.time() - start_time))

	hashlist = []
	''' formatting original list '''
	for item in hashs_list:
		hashlist.append(item[0])
	
	hashduple = []
	
	if duplicate:
		for i in set(hashlist):
			value = hashlist.count(i)
			if value > 1: hashduple.append(i+' '+str(value))
	
		if hashduple:
			print('\r')
			for duple in hashduple:
				print(duple)
			print('\r')

		print('--[ '+str(len(hashduple))+' hash duplicated found')
	
	else:
		print('--[ '+str(len(hashlist)-len(set(hashlist)))+' hash duplicated found')
	
	print('--[ '+str(len(empty_list))+' empty file found')
